// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_COMBO_PF2, m_cbxMask);
	DDX_Control(pDX, IDC_COMBO_PF, m_cbxLevel);
	DDX_Control(pDX, IDC_COMBO_MODE, m_cbxVersion);
	DDX_Control(pDX, IDC_COMBO_MODULE_SIZE, m_cbxModuleSize);
	DDX_Control(pDX, IDC_EDIT_HEIGHT, m_txtHeight);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_txtWidth);
	DDX_Control(pDX, IDC_COMBO_ORIENTATION, m_cbxOrientation);
	DDX_Control(pDX, IDC_EDIT_MESSAGE, m_txtMessage);
	DDX_Control(pDX, IDC_QRCODE1, m_QRCtrl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PRINT1, OnButtonPrint1)
	ON_BN_CLICKED(IDC_BUTTON_BMP, OnButtonBmp)
	ON_BN_CLICKED(IDC_BUTTON_PRINT2, OnButtonPrint2)
	ON_BN_CLICKED(IDC_BUTTON_WMF, OnButtonWmf)
	ON_BN_CLICKED(IDC_BUTTON_COPY, OnButtonCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_txtMessage.SetWindowText("1234");
	m_cbxVersion.SetCurSel(0);
	m_cbxModuleSize.SetCurSel(2);
	m_cbxLevel.SetCurSel(0);
	m_cbxMask.SetCurSel(2);
	m_cbxOrientation.SetCurSel(0);
	m_txtWidth.SetWindowText("90");
	m_txtHeight.SetWindowText("100");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoDlg::Update_Barcode()
{
	CString tmp;
	double d;

	m_txtMessage.GetWindowText(tmp);
	m_QRCtrl.SetData(tmp);

	m_QRCtrl.SetVersion(m_cbxVersion.GetCurSel());
	m_QRCtrl.SetMask(m_cbxMask.GetCurSel());
	m_QRCtrl.SetOrientation(m_cbxOrientation.GetCurSel());
	m_QRCtrl.SetLevel(m_cbxLevel.GetCurSel());

	m_cbxModuleSize.GetWindowText(tmp);
	d = strtod(tmp, 0);
	m_QRCtrl.SetModuleSize((float)d);

	m_txtWidth.GetWindowText(tmp);
	m_ExtraWidth = strtoul(tmp, 0, 10);

	m_txtHeight.GetWindowText(tmp);
	m_ExtraHeight = strtoul(tmp, 0, 10);
}

void CDemoDlg::OnButtonPrint1() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	long ActualWidth, ActualHeight;
	HDC hPrinterDC;

    // Get the "Printer Dialog"
	CPrintDialog *printerDlg = new CPrintDialog(FALSE, PD_ALLPAGES | PD_RETURNDC, NULL);

    // Do the initialization 
	printerDlg->m_pd.nFromPage = printerDlg->m_pd.nToPage = 1;
    printerDlg->m_pd.nMinPage = printerDlg->m_pd.nMaxPage = 1;

    // Display the "Printer Dialog"
    printerDlg->DoModal();

    // Get the handle of the printer.
    hPrinterDC = printerDlg->GetPrinterDC();
    if (hPrinterDC != NULL)
    {
		CDC *pDC = new CDC;
		// Attach the printer DC
        pDC->Attach(hPrinterDC);     

		// Start a new print job
        pDC->StartDoc("sample barcode");  
                                 
		// Start a new page
        pDC->StartPage();

		// Get the actual barcode width and height
		// The size value is based on the printer resolution
		m_QRCtrl.GetActualSize(FALSE, (long)hPrinterDC, &ActualWidth, &ActualHeight);

		// Image size = barcode size + surrounding white space
		if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2)
			m_QRCtrl.SetSize(ActualWidth + m_ExtraWidth, ActualHeight + m_ExtraHeight);
		else
			m_QRCtrl.SetSize(ActualHeight + m_ExtraWidth, ActualWidth + m_ExtraHeight);

		// The barcode is printed at the point (100, 500)
		// (x = 100, y = 500)
		m_QRCtrl.Render((long)(pDC->m_hDC), 100, 500);

		// End the current page
        pDC->EndPage();            

		// End the current print job
        pDC->EndDoc();    
		
		// Detach the printer DC
        pDC->Detach();
		
        delete pDC;
	}

    delete printerDlg;
}

void CDemoDlg::OnButtonPrint2() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	HDC hPrinterDC;

    // Get the "Printer Dialog"
	CPrintDialog *printerDlg = new CPrintDialog(FALSE, PD_ALLPAGES | PD_RETURNDC, NULL);

    // Do the initialization 
	printerDlg->m_pd.nFromPage = printerDlg->m_pd.nToPage = 1;
    printerDlg->m_pd.nMinPage = printerDlg->m_pd.nMaxPage = 1;

    // Display the "Printer Dialog"
    printerDlg->DoModal();

    // Get the handle of the printer.
    hPrinterDC = printerDlg->GetPrinterDC();
    if (hPrinterDC != NULL) {
		CDC *pDC = new CDC;
		// Attach the printer DC
        pDC->Attach(hPrinterDC);     

		// Start a new print job
        pDC->StartDoc("sample barcode");  
                                 
		// Start a new page
        pDC->StartPage();

		short *data = new short[1];
		long size = 1;
		BOOL result;
		short PatternRows, PatternCols;
		short RectWidth, RectHeight;
		short New_Rows, New_Cols;

		// First get the buffer size
		m_QRCtrl.GetPatternData(data, &size, &PatternRows, &PatternCols, &result);
		if (!result) {
			// Create an array
			delete [] data;
			data = new short[size];

			// Obtain the pattern matrix data
			m_QRCtrl.GetPatternData(data, &size, &PatternRows, &PatternCols, &result);
		}

		if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2) {
			RectWidth = (int)(::GetDeviceCaps(hPrinterDC, LOGPIXELSX) * m_QRCtrl.GetModuleSize() /2.54);
			RectHeight = RectWidth;

			New_Rows = PatternRows;
			New_Cols = PatternCols;
		}
		else {
			RectHeight = (int)(::GetDeviceCaps(hPrinterDC, LOGPIXELSY) * m_QRCtrl.GetModuleSize() /2.54);
			RectWidth = RectHeight;

			New_Cols = PatternRows;
			New_Rows = PatternCols;
		}
		
		HBRUSH sb = CreateSolidBrush(RGB(0, 0, 0));
		
		int Start_X = 100;
		int Start_Y = 150;
		int X = Start_X;
		int Y = Start_Y;
		BOOL IsBlackModule;
        short BlackModuleCount;
		
		for (int i = 1; i <= New_Rows; i++) {
			X = Start_X;
			for (int j = 1; j <= New_Cols; j++) {
				short OneElement = GetElement(data, New_Rows, New_Cols, i, j);

				if (j == 1) {
					// First module of current row
					if (OneElement == '1') {
						// Black module
						IsBlackModule = true;
						BlackModuleCount = 1;
					}
					else {
						// White module (no drawing)
						IsBlackModule = false;
						BlackModuleCount = 0;	
						X = X + RectWidth;
					}
				}
				else if (OneElement == '1' && IsBlackModule) {
					// Another black module
					BlackModuleCount = BlackModuleCount + 1;
				}
				else if (OneElement == '1' && !IsBlackModule) {
					// A black module appears
					IsBlackModule = true;
					BlackModuleCount = 1;
				}
				else if (OneElement == '0' && IsBlackModule) {
					// Draw continuous black modules
					RECT rc;
					rc.left = X;
					rc.top = Y;
					rc.right = rc.left + BlackModuleCount * RectWidth;
					rc.bottom = rc.top + RectHeight;
            
					FillRect(hPrinterDC, &rc, sb);
					X = X + BlackModuleCount * RectWidth;
					X = X + RectWidth;
            
					IsBlackModule = false;
				}
				else if (OneElement == '0' && !IsBlackModule) {
					// White module (no drawing)
					X = X + RectWidth;
				}
			}

			if (IsBlackModule) {
				// Draw continuous black modules
				RECT rc;
				rc.left = X;
				rc.top = Y;
				rc.right = rc.left + BlackModuleCount * RectWidth;
				rc.bottom = rc.top + RectHeight;
        
				FillRect(hPrinterDC, &rc, sb);
			}
			Y = Y + RectHeight;
		}

		// End the current page
        pDC->EndPage();            

		// End the current print job
        pDC->EndDoc();    
		
		// Detach the printer DC
        pDC->Detach();
		
        delete pDC;

		delete [] data;

		DeleteObject(sb);
	}

    delete printerDlg;
}

short CDemoDlg::GetElement(short *Data, short RowsCount, short ColsCount, short RowIndex, short ColIndex)
{
	if (m_cbxOrientation.GetCurSel() == 0)
		return *(Data + (RowIndex - 1) * ColsCount + ColIndex - 1);
	else if (m_cbxOrientation.GetCurSel() == 1)
		return *(Data + (ColIndex - 1) * RowsCount + RowsCount - RowIndex);
	else if (m_cbxOrientation.GetCurSel() == 2)
		return *(Data + (RowsCount - RowIndex) * ColsCount + ColsCount - ColIndex);
	else
		return *(Data + (ColsCount - ColIndex) * RowsCount + RowIndex - 1);
}

void CDemoDlg::OnButtonBmp() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
	m_QRCtrl.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2)
		m_QRCtrl.SetSize(ActualWidth + m_ExtraWidth, ActualHeight + m_ExtraHeight);
	else
		m_QRCtrl.SetSize(ActualHeight + m_ExtraWidth, ActualWidth + m_ExtraHeight);

	m_QRCtrl.SaveAsBMP("c:\\barcode.bmp");
}

void CDemoDlg::OnButtonWmf() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
	m_QRCtrl.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2)
		m_QRCtrl.SetSize(ActualWidth + m_ExtraWidth, ActualHeight + m_ExtraHeight);
	else
		m_QRCtrl.SetSize(ActualHeight + m_ExtraWidth, ActualWidth + m_ExtraHeight);

	m_QRCtrl.SaveAsWMF("c:\\barcode.wmf");
}

void CDemoDlg::OnButtonCopy() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
	m_QRCtrl.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2)
		m_QRCtrl.SetSize(ActualWidth + m_ExtraWidth, ActualHeight + m_ExtraHeight);
	else
		m_QRCtrl.SetSize(ActualHeight + m_ExtraWidth, ActualWidth + m_ExtraHeight);

	m_QRCtrl.CopyToClipboard();
}

void CDemoDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

